﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

// ** WHEN PLATEBODIES ARE IMPLEMENTED - MUST MAKE SHIELDS AND BODIES EQUIPPEDABLE (is that a word?) TOGETHER
public class ArmouryShopButton : MonoBehaviour {

    public PlayerStats stats; // to set the armour
    public int armourNumber;
    public Text armourName;
    public Text description;
    public Text cost;
    public Image imageDisplay;
    private ArmourStats[] armours; // to get access to armour array
    public Money money; // to access and manipulate coin amount
    private int price;
    public Button shopButton; // to access button colours
    private ColorBlock block;

    public bool purchased; // to check if the armour is purchased or not for display reasons
    // ** brute force purchased persistence over scenes. Will continue to try to make this dynamic during the polish stage
    private static bool purchasedWood = false;
    private static bool purchasedRound = false;
    private static bool purchasedSpider = false;
    private static bool purchasedStone = false;
    private static bool purchasedEngraved = false;
    private static bool purchasedPlate = false;

    /*
     * BUTTON NAVIGATION IS SET TO NONE - WILL HAVE TO TWEAK IF WE DECIDE ON CONTROLLER IMPLEMENTATION
     * this fixes the button staying on the highlighted colour when clicked, will most likely do the same
     * for the character creation screen.
     */

        
    void Start() {
        //money = GameObject.Find("Coins").GetComponent<Money>();
        //shopButton = GameObject.Find("Button").GetComponent<Button>();
        stats = GameObject.Find("ShopPlayer").GetComponent<PlayerStats>();
        armours = GameObject.Find("Canvas").GetComponent<ArmourList>().armours;
        price = armours[armourNumber].cost;
        setButton();
        block = new ColorBlock();
        block = shopButton.colors;

        // *** BRUTE FORCE purchased code - hopefully to be changed
        if (armours[armourNumber].armourName == "Wood Shield" && purchasedWood == true) {
            purchased = true;
        }
        else if (armours[armourNumber].armourName == "Round Shield" && purchasedRound == true) {
            purchased = true;
        }
        else if (armours[armourNumber].armourName == "Spider Shield" && purchasedSpider == true) {
            purchased = true;
        }
        if (armours[armourNumber].armourName == "Stone Shield" && purchasedStone == true) {
            purchased = true;
        }
        if (armours[armourNumber].armourName == "Engraved Stone Shield" && purchasedEngraved == true) {
            purchased = true;
        }
        if (armours[armourNumber].armourName == "Plate Shield" && purchasedPlate == true) {
            purchased = true;
        }
    }


    // neccesary for colour changes to be in update.
    void Update() {
        // changing on press colors
        if (money.getMoney() >= price || cost.text == "PURCHASED" || cost.text == "EQUIPPED") {
            block.pressedColor = Color.gray;
            shopButton.colors = block;
            if (cost.text == "EQUIPPED") {
                cost.color = Color.green;
            }
            else {
                cost.color = Color.black;
            }
        }
        else {
            block.pressedColor = Color.red; // can't afford = red click
            shopButton.colors = block;
        }

        /*
        // changing between the cost, "purchased", and "equipped"
        if (stats.getWeapon().weaponName == armours[armourNumber].weaponName) {
            cost.text = "EQUIPPED";
        }
        else if (purchased == true) {
            cost.text = "PURCHASED";
        }
        else {
            cost.text = armours[armourNumber].cost.ToString();
        }
        */

    }

    // created by following the 'Creating An In-Game Shop' shop tutorial on unity3d.com
    // dynamically allocates the shop buttons based on created armour
    void setButton() {
        string costToString = armours[armourNumber].cost.ToString(); // convert float to string
        armourName.text = armours[armourNumber].armourName;
        description.text = armours[armourNumber].armourDescription;
        imageDisplay.sprite = armours[armourNumber].image;
        cost.text = armours[armourNumber].cost.ToString(); // will be able to remove
    }

    public void OnClick() {
        // buying the armour based on currency
        if (money.getMoney() >= price && cost.text != "PURCHASED" && cost.text != "EQUIPPED") {
            money.decreaseCoins(price);
            //stats.setWeapon(armours[armourNumber]);   -- change to setShield, etc.
            cost.color = Color.green;
            purchased = true;

            /* TO BE CHANGED TO ARMOR
             * 
             * 
            // *** BRUTE FORCE purchased code - hopefully to be changed
            if (stats.getWeapon().weaponName == "Basic Axe") {
                purchasedBasicAxe = true;
            }
            else if (stats.getWeapon().weaponName == "Medium Axe") {
                purchasedMedAxe = true;
            }
            else if (stats.getWeapon().weaponName == "Heavy Axe") {
                purchasedHeavyAxe = true;
            }
            else if (stats.getWeapon().weaponName == "Short Sword") {
                purchasedBasicAxe = true;
            }
            else if (stats.getWeapon().weaponName == "Long Sword") {
                purchasedMedAxe = true;
            }
            else if (stats.getWeapon().weaponName == "Katana") {
                purchasedHeavyAxe = true;
            }
            */
        }
        else if (cost.text == "PURCHASED") { // already purchased, just equip.
            //stats.setWeapon(armours[armourNumber]);
            cost.text = "EQUIPPED";
        }
        else {
            // will implement sound that the player cannot afford here. (visual handled in update)
        }


    }

    // to display armour stats when you hover over armour buttons
    public void HoverEnter() {
        /* SWITCH TO ARMOUR
        description.text = "Damage:\n" + weapons[weaponNumber].damageMin.ToString() + " - "
            + weapons[weaponNumber].damageMax.ToString() + "\n\n" + "Attack Speed:\n"
            + weapons[weaponNumber].attackSpeed.ToString();
        */
    }

    // to revert back to the original description
    public void HoverExit() {
        description.text = armours[armourNumber].armourDescription;
    }
    
}
